DCMTK: FGFrameVOILUT Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Static Public Attributes | Private Attributes | List of all members
FGFrameVOILUT Class Reference

Class representing the "Frame VOI LUT" Functional Group Macro. More...

Inheritance diagram for FGFrameVOILUT:

## Public Member Functions
| FGFrameVOILUT ()
| Constructor creating empty functional group.
virtual | ~FGFrameVOILUT ()
| Virtual destructor.
virtual FGBase * | clone () const
| Returns a deep copy of this object.
virtual DcmFGTypes::E_FGSharedType | getSharedType () const
| Get shared type of this kind functional group (can be both, per-frame or shared)
virtual void | clearData ()
| Clear old values.
virtual OFCondition | check () const
| Check whether functional group contains valid data.
virtual OFCondition | read (DcmItem &item)
| Read Frame VOI LUT Sequence from given item.
virtual OFCondition | write (DcmItem &item)
| Write Frame VOI LUT Sequence to given item.
virtual OFCondition | getWindowCenter (Float64 &value, const unsigned long pos=0)
| Get Window Center.
virtual OFCondition | getWindowWidth (Float64 &value, const unsigned long pos=0)
| Get Window Width.
virtual OFCondition | getWindowCenterAndWindowWidthExplanation (OFString &value, const unsigned long pos=0)
| Get Window Center and Window Width Explanation.
virtual OFCondition | getCenterWidthExplanation (Float64 &windowCenter, Float64 &windowWidth, OFString &explanation)
| Get tripe of information: Window Center, Window With, Window Center and Window Width Explanation.
virtual OFCondition | getVOILUTFunction (OFString &value, const unsigned long pos=0)
| Get VOI LUT Function.
virtual OFCondition | setWindowCenter (const OFString &value, const OFBool checkValue=OFTrue)
| Set Window Center.
virtual OFCondition | setWindowWidth (const OFString &value, const OFBool checkValue=OFTrue)
| Set Window Width.
virtual OFCondition | setCenterWidthExplanation (const Float64 &windowCenter, const Float64 &windowWidth, const OFString &explanation="", const OFBool checkValue=OFTrue)
| Set Window Center and Window Width Explanation.
virtual OFCondition | setVOILUTFunction (const OFString &value, const OFBool checkValue=OFTrue)
| Set VOI LUT Function.
virtual int | compare (const FGBase &rhs) const
| Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!
Public Member Functions inherited from FGBase
| FGBase (const DcmFGTypes::E_FGType fgType)
| Constructor, creates new functional group of given type.
virtual DcmFGTypes::E_FGType | getType () const
| Return the type of this functional group.
virtual | ~FGBase ()
| Virtual destructor.

## Static Public Attributes
static const OFString | DT_CT_WindowCenterWidthExplanation_Brain
| Defined Term "BRAIN" for tag Window Center & Width Explanation (0028,1055) for CT objects.
static const OFString | DT_CT_WindowCenterWidthExplanation_SoftTissue
| Defined Term "SOFT_TISSUE" for tag Window Center & Width Explanation (0028,1055) for CT objects.
static const OFString | DT_CT_WindowCenterWidthExplanation_Lung
| Defined Term "LUNG" for tag Window Center & Width Explanation (0028,1055) for CT objects.
static const OFString | DT_CT_WindowCenterWidthExplanation_Bone
| Defined Term "BONE" for tag Window Center & Width Explanation (0028,1055) for CT objects.

## Private Attributes
DcmDecimalString | m_WindowCenter
| Window Center (DS, VM 1-n, Required type 1)
DcmDecimalString | m_WindowWidth
| Window Width (DS, VM 1-n, Required type 1)
DcmLongString | m_WindowCenterWindowWidthExplanation
| Window Center & Window Width Explanation (LO, VM 1-n, Required type 3)
DcmCodeString | m_VOILUTFunction
| VOI LUT Function (CS, VM 1, Requirement Type 3)

## Additional Inherited Members
Protected Member Functions inherited from FGBase
virtual OFCondition | getItemFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, const unsigned long itemNum, DcmItem *&result)
| Get the item containing the payload of a functional group sequence, identified by the functional group's sequence key provided and the desired item number.
virtual OFCondition | getNumItemsFromFGSequence (DcmItem &source, const DcmTagKey &seqKey, unsigned long &result)
| Get number of items in a functional group sequence, identified by the functional group's sequence key.
virtual OFCondition | createNewFGSequence (DcmItem &destination, const DcmTagKey &seqKey, const unsigned long numItems, DcmItem *&firstItem)
| Create functional group sequence specified by given sequence tag key.

## Detailed Description

Class representing the "Frame VOI LUT" Functional Group Macro.

## Member Function Documentation

## ◆ check()

virtual OFCondition FGFrameVOILUT::check | ( |  | ) | const
| virtual

Check whether functional group contains valid data.

Returns
  EC_Normal if data is valid, error otherwise

Implements FGBase.

## ◆ clone()

virtual FGBase * FGFrameVOILUT::clone | ( |  | ) | const
| virtual

Returns a deep copy of this object.

Returns
  Deep copy of this object

Implements FGBase.

References FGBase::FGBase().

## ◆ compare()

virtual int FGFrameVOILUT::compare | ( | const FGBase & | rhs | ) | const
| virtual

Comparison operator that compares the normalized value of this object with a given object of the same type, i.e. the elements within both functional groups (this and rhs parameter) are compared by value!

Both objects (this and rhs) need to have the same type (i.e. both FGUnknown) to be comparable. This function is used in order to decide whether a functional group already exists, or is new. This is used in particular to find out whether a given functional group can be shared (i.e. the same information already exists as shared functional group) or is different from the same shared group. In that case the shared functional group must be distributed into per-frame functional groups, instead. The exact implementation for implementing the comparison is not relevant. However, it must be a comparison by value.

Parameters

  rhs | the right hand side of the comparison

Returns
  0 if the object values are equal. -1 if either the value of the first component that does not match is lower in the this object, or all compared components match but this component is shorter. Also returned if this type and rhs type (DcmFGTypes::E_FGType) do not match. 1 if either the value of the first component that does not match is greater in this object, or all compared components match but this component is longer.

Implements FGBase.

References FGBase::FGBase().

## ◆ getCenterWidthExplanation()

virtual OFCondition FGFrameVOILUT::getCenterWidthExplanation | ( | Float64 & | windowCenter,
|  | Float64 & | windowWidth,
|  | OFString & | explanation )
| virtual

Get tripe of information: Window Center, Window With, Window Center and Window Width Explanation.

Parameters

  windowCenter | Reference to variable in which Window Center should be stored
  windowWidth | Reference to variable in which Window Width should be stored
  explanation | Reference to variable in which Window Center and Window Width Explanation should be stored

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getSharedType()

virtual DcmFGTypes::E_FGSharedType FGFrameVOILUT::getSharedType | ( |  | ) | const
| inlinevirtual

Get shared type of this kind functional group (can be both, per-frame or shared)

Returns
  Always returns DcmFGTypes::EFGS_BOTH

Implements FGBase.

References DcmFGTypes::EFGS_BOTH.

## ◆ getVOILUTFunction()

virtual OFCondition FGFrameVOILUT::getVOILUTFunction | ( | OFString & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get VOI LUT Function.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getWindowCenter()

virtual OFCondition FGFrameVOILUT::getWindowCenter | ( | Float64 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Window Center.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getWindowCenterAndWindowWidthExplanation()

virtual OFCondition FGFrameVOILUT::getWindowCenterAndWindowWidthExplanation | ( | OFString & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Window Center and Window Width Explanation.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ getWindowWidth()

virtual OFCondition FGFrameVOILUT::getWindowWidth | ( | Float64 & | value,
|  | const unsigned long | pos = 0 )
| virtual

Get Window Width.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1)

Returns
  EC_Normal if successful, an error code otherwise

## ◆ read()

virtual OFCondition FGFrameVOILUT::read | ( | DcmItem & | item | ) |
| virtual

Read Frame VOI LUT Sequence from given item.

Parameters

  item | The item to read from

Returns
  EC_Normal if reading was successful, error otherwise

Implements FGBase.

## ◆ setCenterWidthExplanation()

virtual OFCondition FGFrameVOILUT::setCenterWidthExplanation | ( | const Float64 & | windowCenter,
|  | const Float64 & | windowWidth,
|  | const OFString & | explanation = "",
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Window Center and Window Width Explanation.

Parameters

  windowCenter | Value for Window Center
  windowWidth | Value for Window Width
  explanation | Value for Window Center and Window Width Explanation should be stored
  checkValue | Check 'value' for conformance with VR (DS) and VM (1-n) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setVOILUTFunction()

virtual OFCondition FGFrameVOILUT::setVOILUTFunction | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set VOI LUT Function.

Parameters

  value | Value for VOI LUT Function
  checkValue | Check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setWindowCenter()

virtual OFCondition FGFrameVOILUT::setWindowCenter | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Window Center.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (DS) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setWindowWidth()

virtual OFCondition FGFrameVOILUT::setWindowWidth | ( | const OFString & | value,
|  | const OFBool | checkValue = OFTrue )
| virtual

Set Window Width.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value'. Not evaluated (here for consistency with other setter functions).

Returns
  EC_Normal if successful, an error code otherwise

## ◆ write()

virtual OFCondition FGFrameVOILUT::write | ( | DcmItem & | item | ) |
| virtual

Write Frame VOI LUT Sequence to given item.

Parameters

  item | The item to write to

Returns
  EC_Normal if writing was successful, error otherwise

Implements FGBase.

The documentation for this class was generated from the following file:

- dcmfg/include/dcmtk/dcmfg/fgframevoilut.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2